package blusunrize.immersiveengineering.common.blocks.wooden;

import blusunrize.immersiveengineering.common.blocks.IEBlockInterfaces.IDirectionalTile;
import blusunrize.immersiveengineering.common.blocks.IEBlockInterfaces.IHammerInteraction;
import blusunrize.immersiveengineering.common.blocks.IEBlockInterfaces.INeighbourChangeTile;
import blusunrize.immersiveengineering.common.blocks.TileEntityIEBase;
import net.minecraft.block.BlockPistonBase;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;

import java.util.HashSet;
import java.util.function.Predicate;

public class TileEntityTurntable extends TileEntityIEBase implements IDirectionalTile, INeighbourChangeTile, IHammerInteraction
{
	public static HashSet<Predicate<IBlockState>> permittedRotation = new HashSet<>();
	static{
		permittedRotation.add(state -> {
			//preventing extended pistons from rotating
			return !((state.func_177230_c()==Blocks.field_150331_J||state.func_177230_c()==Blocks.field_150320_F)&&state.func_177229_b(BlockPistonBase.field_176320_b));
		});
	}

	private EnumFacing facing = EnumFacing.UP;
	private boolean redstone = false;
	public boolean invert = false;

	@Override
	public void readCustomNBT(NBTTagCompound nbt, boolean descPacket)
	{
		facing = EnumFacing.func_82600_a(nbt.func_74762_e("facing"));
		redstone = nbt.func_74767_n("redstone");
		invert = nbt.func_74767_n("invert");
	}
	@Override
	public void writeCustomNBT(NBTTagCompound nbt, boolean descPacket)
	{
		nbt.func_74768_a("facing", facing.ordinal());
		nbt.func_74757_a("redstone", redstone);
		nbt.func_74757_a("invert", invert);
	}

	@Override
	public void onNeighborBlockChange(BlockPos pos)
	{
		boolean r = this.field_145850_b.func_175640_z(pos);
		if(r!=this.redstone)
		{
			this.redstone = r;
			if(this.redstone)
			{
				BlockPos target = pos.func_177972_a(facing);
				IBlockState state = this.field_145850_b.func_180495_p(target);
				for(Predicate<IBlockState> pred : permittedRotation)
					if(!pred.test(state))
						return;
				state.func_177230_c().rotateBlock(this.field_145850_b, target, invert?facing:facing.func_176734_d());
			}
		}
	}

	@Override
	public EnumFacing getFacing()
	{
		return facing;
	}
	@Override
	public void setFacing(EnumFacing facing)
	{
		this.facing = facing;
	}
	@Override
	public int getFacingLimitation()
	{
		return 1;
	}
	@Override
	public boolean mirrorFacingOnPlacement(EntityLivingBase placer)
	{
		return placer.func_70093_af();
	}
	@Override
	public boolean canHammerRotate(EnumFacing side, float hitX, float hitY, float hitZ, EntityLivingBase entity)
	{
		return !entity.func_70093_af();
	}
	@Override
	public boolean canRotate(EnumFacing axis)
	{
		return true;
	}

	@Override
	public boolean hammerUseSide(EnumFacing side, EntityPlayer player, float hitX, float hitY, float hitZ)
	{
		if(player.func_70093_af())
		{
			invert = !invert;
			func_70296_d();
			field_145850_b.func_175641_c(func_174877_v(), this.func_145838_q(), 254, 0);
			return true;
		}
		return false;
	}
}
